%global commit b151cd42cbe25ead1ba2a79165fa4123ade2dac3
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global module catkin_tools

%if 0%{?fedora} > 12
%global with_python3 1
%else
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib())")}
%endif

Name:           python-%{module}
Version:        0.2.0
Release:        2%{?dist}
Summary:        Command line tools for working with catkin

Group:          Development/Tools
License:        ASL 2.0
URL:            http://catkin-tools.readthedocs.org
Source0:        https://github.com/catkin/%{module}/archive/%{commit}/%{module}-%{commit}.tar.gz
# Upstream patch
Patch0:         %{name}-0.2.0-terminal-width.patch

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-argparse
BuildRequires:  python-catkin_pkg
BuildRequires:  cmake
%if 0%{?fedora} > 19 || 0%{?rhel} > 6
BuildRequires:  python-flake8
%endif
BuildRequires:  python-mock
BuildRequires:  python-nose
BuildRequires:  python-pep8
BuildRequires:  python-setuptools
%if 0%{?rhel} && 0%{?rhel} <= 6
BuildRequires:  python-sphinx10
%else
BuildRequires:  python-sphinx
%endif
BuildRequires:  PyYAML
Requires:       python-argparse
Requires:       python-catkin_pkg
Requires:       python-setuptools
Requires:       PyYAML

%if 0%{?with_python3}
%package -n python3-%{module}
Summary:        Command line tools for working with catkin
BuildRequires:  python3-catkin_pkg
BuildRequires:  cmake
BuildRequires:  python3-devel
%if 0%{?fedora} > 19 || 0%{?rhel} > 6
BuildRequires:  python3-flake8
%endif
BuildRequires:  python3-mock
BuildRequires:  python3-nose
BuildRequires:  python3-pep8
BuildRequires:  python3-sphinx
BuildRequires:  python3-PyYAML
Requires:       python3-catkin_pkg
Requires:       python3-setuptools
Requires:       python3-PyYAML
%endif

%description
Provides command line tools for working with catkin

%if 0%{?with_python3}
%description -n python3-%{module}
Provides command line tools for working with catkin
%endif

%prep
%setup -qn %{module}-%{commit}
%patch0 -p1

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
find %{py3dir} -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python3}|'
%endif

find -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python2}|'

%build
%{__python2} setup.py build
%if 0%{?rhel} && 0%{?rhel} <= 6
make -C docs html man SPHINXBUILD=sphinx-1.0-build
%else
make -C docs html man
%endif
rm -f docs/_build/html/.buildinfo

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
make -C docs html man
pushd docs/_build/man
for f in *; do mv $f python3-$f; done
popd
rm -f docs/_build/html/.buildinfo
popd
%endif

%install
%{__python2} setup.py install --skip-build --root %{buildroot}
install -d %{buildroot}%{_mandir}/man1
install -p -m0644 docs/_build/man/*.1 %{buildroot}%{_mandir}/man1/

# Removed the installed test
rm -rf %{buildroot}%{python2_sitelib}/tests

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root %{buildroot} --install-scripts %{_bindir}3
pushd %{buildroot}%{_bindir}3
for f in *; do mv $f %{buildroot}%{_bindir}/python3-$f; done
popd
rmdir %{buildroot}%{_bindir}3
install -p -m0644 docs/_build/man/*.1 %{buildroot}%{_mandir}/man1/

# Removed the installed test
rm -rf %{buildroot}%{python3_sitelib}/tests
popd
%endif

%if 0%{?fedora} > 19 || 0%{?rhel} > 6
%check
# The tests depend on "catkin" being in PATH.
mkdir -p tmpbin
ln -s %{buildroot}%{_bindir}/catkin tmpbin/catkin
PYTHONPATH=%{buildroot}%{python2_sitelib} PATH=`pwd`/tmpbin:$PATH nosetests -w tests -e test_build_*

%if 0%{?with_python3}
mkdir -p tmpbin3
ln -s %{buildroot}%{_bindir}/python3-catkin tmpbin3/catkin
PYTHONPATH=%{buildroot}%{python2_sitelib} PATH=`pwd`/tmpbin3:$PATH nosetests-%{python3_version} -w tests -e test_build_*
%endif
%endif

%files
%doc LICENSE README.md docs/_build/html
%{python2_sitelib}/%{module}
%{python2_sitelib}/%{module}-%{version}-py?.?.egg-info
%{_bindir}/catkin
%{_mandir}/man1/%{module}.1.gz

%if 0%{?with_python3}
%files -n python3-%{module}
%doc LICENSE README.md docs/_build/html
%{python3_sitelib}/%{module}
%{python3_sitelib}/%{module}-%{version}-py?.?.egg-info
%{_bindir}/python3-catkin
%{_mandir}/man1/python3-%{module}.1.gz
%endif

%changelog
* Wed Oct 22 2014 Scott K Logan <logans@cottsay.net> - 0.2.0-2
- Add upstream terminal width patch to enable tests

* Sat Oct 18 2014 Scott K Logan <logans@cottsay.net> - 0.2.0-1
- Update to 0.2.0
- Add python3 package
- Exclude new test_build_* tests because they require catkin
- Disable buildfarm testing (https://github.com/catkin/catkin_tools/issues/122)

* Tue Jun 10 2014 Scott K Logan <logans@cottsay.net> - 0.1.0-1
- Initial package
